/*
   gcc -o example example.c -larguments
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <arguments.h>

double scale;

void process_file (char *name, int verbosity, char *foo, 
   int bar, int hops)
{
  printf ("Processing file \"%s\"\n  verbosity level is %d\n  foo=\"%s\""
     "\n  bar=%s\n  hops=%d\n  scale=%f\n\n", name, verbosity, foo, 
     bar != 0 ? "no" : "yes", hops, scale);
}



ARGUMENT_CALLBACK (argument_data)
{
  if (strlen (parameter) < 6)
    arguments_error (arg,
      "should be at least 6 characters long.");
  arg -> value = parameter;
}

ARGUMENT_CALLBACK (argument_unit)
{
  if (strcasecmp (parameter, "pt") == 0)
    scale = 1;
  else if (strcasecmp (parameter, "in") == 0)
    scale = 72;
  else if (strcasecmp (parameter, "mm") == 0)
    scale = 2.8346457;
  else
    arguments_error_freeform ("Invalid unit of"
       " measure given (%s)", parameter);
}

struct Argument arguments [] =
{
  { 'f', "foo",     argument_data,
            ARGUMENT_F_ONCE | ARGUMENT_F_PAR,  NULL },
  { 'b', "bar",     argument_bool,
            ARGUMENT_F_ONCE, NULL },
  { 'h', "hops",    argument_int,
            ARGUMENT_F_ONCE | ARGUMENT_F_PAR,  NULL },
  { 's', "scale",   argument_unit,
            ARGUMENT_F_PAR, NULL },
  { 'v', "verbose", argument_bool, 0, (void *) 3 },
                   /* default verbosity level is 3 */
  { 'q', "quiet",   argument_bool, 0, (void *) 0 },
  { }
};

int main (int argc, char **argv)
{
  int p;
  p = 0;
  while (p < argc - 1)
  {
    scale = 1;
    arguments [0].value = "none";
    arguments [0].flags &= ~ARGUMENT_F_OCC;
    arguments [1].value = NULL;
    arguments [1].flags &= ~ARGUMENT_F_OCC;
    arguments [2].value = NULL;
    arguments [2].flags &= ~ARGUMENT_F_OCC;
    p += arguments_parse ("foo", "1.0", "file name ...",
      "Fooz the filez!", argc - p, argv + p, arguments);
    if (p == argc)
      arguments_error_freeform ("File name is required.");
    process_file (argv [p],
       arguments [3].value - arguments [4].value,
       arguments [0].value,
       arguments [1].value == NULL,
       (int) (arguments [2].value));
  }
  return EXIT_SUCCESS;
}
